'Example for the usage of myTWI Portexpander
'with a myAVR Board
'Port A = Input, Port B = Output
'connect Button to PORT A, LED to PORT B
'If Button on Port A is pressed,
'Port B will be set to high

$regfile = "M8def.dat"
$crystal = 3686400

$lib "i2c_twi.lbx"

Config Scl = Portc.5
Config Sda = Portc.4
Config Twi = 100000                                         'TWI speed

I2cinit

Declare Sub Init_expander
Declare Sub Write_expander(byval Port As Byte , Byval Value As Byte)
Declare Sub Read_expander(byval Port As Byte , Value As Byte)

Dim Value As Byte , Temp As Byte

Const Slave = 64                                            'slave address of myTWI Portexpander
Call Init_expander

Do
   Call Read_expander(0 , Value)
      If Value < 255 Then                                   'if Button is pressed
      Call Write_expander(1 , 255)                          'PORTB = high
   Else
      Call Write_expander(1 , 0)                            'PORTB = low
   End If

Loop

Sub Init_expander
   I2cstart
   I2cwbyte Slave                                           'slave address
   I2cwbyte 6                                               'Register 6 --> PORTA CONFIG
   I2cwbyte 255                                             'PORT A = Input
   I2cstop

   I2cstart
   I2cwbyte Slave                                           'slave address
   I2cwbyte 7                                               'Register 7 --> PORTB CONFIG
   I2cwbyte 0                                               'PORT B = Output
   I2cstop
End Sub

Sub Write_expander(byval Port As Byte , Byval Value As Byte)
   Temp = 2 + Port
   I2cstart
   I2cwbyte Slave                                           'slave address
   I2cwbyte Temp                                            'Port to write
   I2cwbyte Value                                           'write value
   I2cstop
End Sub

Sub Read_expander(byval Port As Byte , Value As Byte)
  I2cstart
  I2cwbyte Slave                                            'slave address
  I2cwbyte Port                                             'Port to read
  I2cstart                                                  'repeated start
  I2cwbyte 65                                               'read from slave
  I2crbyte Value , Nack                                     'read byte
  I2cstop
End Sub

End